<?php
/*
Plugin Name: jin_toc_highlight
Plugin URI: https://affiliate-biz.jp/jin_toc_highlight
Description: Jin +Rich Table of Contents 目次をハイライト表示する。　highlight toc for WordPress Theme Jin
Author: pen@あふぃぶ
Author URI: https://affiliate-biz.jp/about
Version: 1.0.0
*/

  add_action( 'wp_head', 'afb_highlight_toc_css' );
  function afb_highlight_toc_css(){
    echo '<style>a.current {background-color:#edf5ff !important;}</style>';
  }

function jin_toc_highlight() {
  echo <<< EOM
  <script>
  const highlight = (e) => {
    const elem = document.querySelectorAll('.rtoc-mokuji a');
    if (elem === null) { 
        return 0;
      } else {        
        for (var i = 0; i < elem.length; i++) {
          const y = document.documentElement.clientHeight;
          const a = document.getElementById( elem[i].hash.slice(1) ).getBoundingClientRect().top;
          if( y > a ){
              elem[i].classList.add("current");
              if ( i>0 ){
              elem[0].classList.remove("current");
              elem[i-1].classList.remove("current");
              }
          } else {
            elem[i].classList.remove("current");}
          }  
    }
  };
  window.addEventListener("scroll", highlight);
  </script>
  EOM;
  }
add_action( 'wp_print_footer_scripts', 'jin_toc_highlight' );

